/*
 * Geotrans.java
 * Created on 22 juin 2000, 16:56
 *
 * @author  finnc
 * @version 
 */
package geotrans;


public class Geotrans extends javax.swing.JFrame {
    
    private Directory currentDir = new Directory(".");
    private JNIEngine jniEngine = new JNIEngine();  
    private JNIStrtoval jniStrtoval = new JNIStrtoval();
    private java.awt.Component prevFocus;
    private MasterPanel upper_mp;
    private MasterPanel lower_mp;
    private jOptions options;
    private java.lang.String currLookAndFeel = "Java";
    
 /** Creates new form Geotrans */
  public Geotrans() {
    initComponents ();
    initialize();
    
    javax.swing.ButtonGroup lookAndFeelGroup = new javax.swing.ButtonGroup();
    lookAndFeelGroup.add(metalRadioButtonMenuItem);
    lookAndFeelGroup.add(unixRadioButtonMenuItem);
    lookAndFeelGroup.add(windowsRadioButtonMenuItem);
    
    // Change title bar icon
    java.net.URL url = getClass().getResource("/geotrans/icons/Icon.gif");
    try
    {
        java.awt.Image img = createImage((java.awt.image.ImageProducer)url.getContent());
        setIconImage(img);
    }
    catch (Exception e)
    {
        e.printStackTrace();
    }
    pack();
    if (Platform.isUnix)
        setSize(new java.awt.Dimension(484, 679));
    new Center(null, this);
  }

  static {
    System.loadLibrary("jnigeotrans");   
    // Load JNI Native library.  .dll or .so
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      geotransMenuBar = new javax.swing.JMenuBar();
      fileMenu = new javax.swing.JMenu();
      openMenuItem = new javax.swing.JMenuItem();
      createFileHeaderMenuItem = new javax.swing.JMenuItem();
      fileMenuSeparator = new javax.swing.JSeparator();
      exitMenuItem = new javax.swing.JMenuItem();
      editMenu = new javax.swing.JMenu();
      cutMenuItem = new javax.swing.JMenuItem();
      copyMenuItem = new javax.swing.JMenuItem();
      pasteMenuItem = new javax.swing.JMenuItem();
      optionsMenu = new javax.swing.JMenu();
      formatMenuItem = new javax.swing.JMenuItem();
      lookAndFeelMenu = new javax.swing.JMenu();
      metalRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
      unixRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
      windowsRadioButtonMenuItem = new javax.swing.JRadioButtonMenuItem();
      datumMenu = new javax.swing.JMenu();
      createDatumMenuItem = new javax.swing.JMenuItem();
      deleteDatumMenuItem = new javax.swing.JMenuItem();
      ellipsoidMenu = new javax.swing.JMenu();
      createEllipsoidMenuItem = new javax.swing.JMenuItem();
      deleteEllipsoidMenuItem = new javax.swing.JMenuItem();
      convertMenu = new javax.swing.JMenu();
      convertDownMenuItem = new javax.swing.JMenuItem();
      convertMenuSeparator = new javax.swing.JSeparator();
      convertUpMenuItem = new javax.swing.JMenuItem();
      helpMenu = new javax.swing.JMenu();
      contentsMenuItem = new javax.swing.JMenuItem();
      helpMenuSeparator = new javax.swing.JSeparator();
      aboutMenuItem = new javax.swing.JMenuItem();
      geotransToolBar = new javax.swing.JToolBar();
      cutButton = new javax.swing.JButton();
      copyButton = new javax.swing.JButton();
      pasteButton = new javax.swing.JButton();
      formatButton = new javax.swing.JButton();
      geotransToolBarSeparator = new javax.swing.JSeparator();
      convertDownButton = new javax.swing.JButton();
      convertUpButton = new javax.swing.JButton();
      upperPanel = new javax.swing.JPanel();
      lowerPanel = new javax.swing.JPanel();
      
      geotransMenuBar.setMinimumSize(new java.awt.Dimension(285, 23));
      fileMenu.setMnemonic(java.awt.event.KeyEvent.VK_F);
      fileMenu.setText("File");
      openMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
      openMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_O);
      openMenuItem.setText("Open");
      openMenuItem.setToolTipText("Open");
      openMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Open16.gif")));
      openMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              openActionPerformed(evt);
          }
      });
      
      fileMenu.add(openMenuItem);
      createFileHeaderMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F2, 0));
      createFileHeaderMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_C);
      createFileHeaderMenuItem.setText("Create File Header");
      createFileHeaderMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Create16.gif")));
      createFileHeaderMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              createFileHeaderActionPerformed(evt);
          }
      });
      
      fileMenu.add(createFileHeaderMenuItem);
      fileMenu.add(fileMenuSeparator);
      exitMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_X);
      exitMenuItem.setText("Exit");
      exitMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Stop16.gif")));
      exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              exitActionPerformed(evt);
          }
      });
      
      fileMenu.add(exitMenuItem);
      geotransMenuBar.add(fileMenu);
      editMenu.setMnemonic(java.awt.event.KeyEvent.VK_E);
      editMenu.setText("Edit");
      cutMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
      cutMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_T);
      cutMenuItem.setText("Cut");
      cutMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Cut16.gif")));
      cutMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              cutActionPerformed(evt);
          }
      });
      
      editMenu.add(cutMenuItem);
      copyMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
      copyMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_C);
      copyMenuItem.setText("Copy");
      copyMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Copy16.gif")));
      copyMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              copyActionPerformed(evt);
          }
      });
      
      editMenu.add(copyMenuItem);
      pasteMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.CTRL_MASK));
      pasteMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_P);
      pasteMenuItem.setText("Paste");
      pasteMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Paste16.gif")));
      pasteMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              pasteActionPerformed(evt);
          }
      });
      
      editMenu.add(pasteMenuItem);
      geotransMenuBar.add(editMenu);
      optionsMenu.setMnemonic(java.awt.event.KeyEvent.VK_O);
      optionsMenu.setText("Options");
      formatMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
      formatMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_F);
      formatMenuItem.setText("Format . . .");
      formatMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Preferences16.gif")));
      formatMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              formatActionPerformed(evt);
          }
      });
      
      optionsMenu.add(formatMenuItem);
      lookAndFeelMenu.setMnemonic(java.awt.event.KeyEvent.VK_L);
      lookAndFeelMenu.setText("Look and Feel");
      metalRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_J, java.awt.event.InputEvent.CTRL_MASK));
      metalRadioButtonMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_J);
      metalRadioButtonMenuItem.setSelected(true);
      metalRadioButtonMenuItem.setText("Java");
      metalRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              lookAndFeelActionPerformed(evt);
          }
      });
      
      lookAndFeelMenu.add(metalRadioButtonMenuItem);
      unixRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_U, java.awt.event.InputEvent.CTRL_MASK));
      unixRadioButtonMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_U);
      unixRadioButtonMenuItem.setText("Unix");
      unixRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              lookAndFeelActionPerformed(evt);
          }
      });
      
      lookAndFeelMenu.add(unixRadioButtonMenuItem);
      windowsRadioButtonMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.event.InputEvent.CTRL_MASK));
      windowsRadioButtonMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_W);
      windowsRadioButtonMenuItem.setText("Windows");
      windowsRadioButtonMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              lookAndFeelActionPerformed(evt);
          }
      });
      
      lookAndFeelMenu.add(windowsRadioButtonMenuItem);
      optionsMenu.add(lookAndFeelMenu);
      geotransMenuBar.add(optionsMenu);
      datumMenu.setMnemonic(java.awt.event.KeyEvent.VK_D);
      datumMenu.setText("Datum");
      createDatumMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F3, 0));
      createDatumMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_C);
      createDatumMenuItem.setText("Create . . .");
      createDatumMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/New16.gif")));
      createDatumMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              createDatumActionPerformed(evt);
          }
      });
      
      datumMenu.add(createDatumMenuItem);
      deleteDatumMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, 0));
      deleteDatumMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_D);
      deleteDatumMenuItem.setText("Delete . . .");
      deleteDatumMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Delete16.gif")));
      deleteDatumMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              deleteDatumActionPerformed(evt);
          }
      });
      
      datumMenu.add(deleteDatumMenuItem);
      geotransMenuBar.add(datumMenu);
      ellipsoidMenu.setMnemonic(java.awt.event.KeyEvent.VK_L);
      ellipsoidMenu.setText("Ellipsoid");
      createEllipsoidMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F5, 0));
      createEllipsoidMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_C);
      createEllipsoidMenuItem.setText("Create . . .");
      createEllipsoidMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/New16.gif")));
      createEllipsoidMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              createEllipsoidActionPerformed(evt);
          }
      });
      
      ellipsoidMenu.add(createEllipsoidMenuItem);
      deleteEllipsoidMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F6, 0));
      deleteEllipsoidMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_D);
      deleteEllipsoidMenuItem.setText("Delete . . .");
      deleteEllipsoidMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Delete16.gif")));
      deleteEllipsoidMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              deleteEllipsoidActionPerformed(evt);
          }
      });
      
      ellipsoidMenu.add(deleteEllipsoidMenuItem);
      geotransMenuBar.add(ellipsoidMenu);
      convertMenu.setMnemonic(java.awt.event.KeyEvent.VK_C);
      convertMenu.setText("Convert");
      convertDownMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F7, 0));
      convertDownMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_U);
      convertDownMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Down16.gif")));
      convertDownMenuItem.setLabel(" Upper to Lower");
      convertDownMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              convertDownActionPerformed(evt);
          }
      });
      
      convertMenu.add(convertDownMenuItem);
      convertMenu.add(convertMenuSeparator);
      convertUpMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F8, 0));
      convertUpMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_L);
      convertUpMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Up16.gif")));
      convertUpMenuItem.setLabel("Lower to Upper");
      convertUpMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              convertUpActionPerformed(evt);
          }
      });
      
      convertMenu.add(convertUpMenuItem);
      geotransMenuBar.add(convertMenu);
      helpMenu.setMnemonic(java.awt.event.KeyEvent.VK_H);
      helpMenu.setText("Help");
      contentsMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
      contentsMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_C);
      contentsMenuItem.setText("Contents");
      contentsMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              helpContentsActionPerformed(evt);
          }
      });
      
      helpMenu.add(contentsMenuItem);
      helpMenu.add(helpMenuSeparator);
      aboutMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.CTRL_MASK));
      aboutMenuItem.setMnemonic(java.awt.event.KeyEvent.VK_A);
      aboutMenuItem.setText("About GEOTRANS...");
      aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              aboutMenuItemActionPerformed(evt);
          }
      });
      
      helpMenu.add(aboutMenuItem);
      geotransMenuBar.add(helpMenu);
      
      getContentPane().setLayout(new java.awt.GridBagLayout());
      java.awt.GridBagConstraints gridBagConstraints1;
      
      setTitle("GEOTRANS V2.2.3 - Geographic Translator V2.2.3");
      setResizable(false);
      addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
              exitForm(evt);
          }
      });
      
      geotransToolBar.setFloatable(false);
      geotransToolBar.setAlignmentX(0.0F);
      geotransToolBar.setMinimumSize(new java.awt.Dimension(25, 25));
      geotransToolBar.setPreferredSize(new java.awt.Dimension(25, 25));
      cutButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Cut16.gif")));
      cutButton.setToolTipText("Cut");
      cutButton.setMaximumSize(new java.awt.Dimension(25, 30));
      cutButton.setMinimumSize(new java.awt.Dimension(17, 21));
      cutButton.setPreferredSize(new java.awt.Dimension(27, 27));
      cutButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              cutActionPerformed(evt);
          }
      });
      
      cutButton.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseEntered(java.awt.event.MouseEvent evt) {
              editButtonMouseEntered(evt);
          }
      });
      
      geotransToolBar.add(cutButton);
      
      copyButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Copy16.gif")));
      copyButton.setToolTipText("Copy");
      copyButton.setMaximumSize(new java.awt.Dimension(25, 30));
      copyButton.setMinimumSize(new java.awt.Dimension(17, 21));
      copyButton.setPreferredSize(new java.awt.Dimension(27, 27));
      copyButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              copyActionPerformed(evt);
          }
      });
      
      copyButton.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseEntered(java.awt.event.MouseEvent evt) {
              editButtonMouseEntered(evt);
          }
      });
      
      geotransToolBar.add(copyButton);
      
      pasteButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Paste16.gif")));
      pasteButton.setToolTipText("Paste");
      pasteButton.setMaximumSize(new java.awt.Dimension(25, 30));
      pasteButton.setMinimumSize(new java.awt.Dimension(17, 21));
      pasteButton.setPreferredSize(new java.awt.Dimension(27, 27));
      pasteButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              pasteActionPerformed(evt);
          }
      });
      
      pasteButton.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseEntered(java.awt.event.MouseEvent evt) {
              editButtonMouseEntered(evt);
          }
      });
      
      geotransToolBar.add(pasteButton);
      
      formatButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Preferences16.gif")));
      formatButton.setToolTipText("Format Options");
      formatButton.setMaximumSize(new java.awt.Dimension(25, 30));
      formatButton.setMinimumSize(new java.awt.Dimension(17, 21));
      formatButton.setPreferredSize(new java.awt.Dimension(27, 27));
      formatButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              formatActionPerformed(evt);
          }
      });
      
      geotransToolBar.add(formatButton);
      
      geotransToolBarSeparator.setOrientation(javax.swing.SwingConstants.VERTICAL);
      geotransToolBar.add(geotransToolBarSeparator);
      
      convertDownButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Down16.gif")));
      convertDownButton.setToolTipText("Convert Upper to Lower");
      convertDownButton.setMaximumSize(new java.awt.Dimension(25, 30));
      convertDownButton.setMinimumSize(new java.awt.Dimension(17, 21));
      convertDownButton.setPreferredSize(new java.awt.Dimension(27, 27));
      convertDownButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              convertDownActionPerformed(evt);
          }
      });
      
      geotransToolBar.add(convertDownButton);
      
      convertUpButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/geotrans/icons/Up16.gif")));
      convertUpButton.setToolTipText("Convert Lower to Upper");
      convertUpButton.setMaximumSize(new java.awt.Dimension(25, 30));
      convertUpButton.setMinimumSize(new java.awt.Dimension(17, 21));
      convertUpButton.setPreferredSize(new java.awt.Dimension(27, 27));
      convertUpButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              convertUpActionPerformed(evt);
          }
      });
      
      geotransToolBar.add(convertUpButton);
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHEAST;
      getContentPane().add(geotransToolBar, gridBagConstraints1);
      
      upperPanel.setLayout(new java.awt.BorderLayout());
      
      upperPanel.setBackground(java.awt.Color.lightGray);
      upperPanel.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED), new javax.swing.border.LineBorder(java.awt.Color.black)));
      upperPanel.setMinimumSize(new java.awt.Dimension(469, 284));
      upperPanel.setPreferredSize(new java.awt.Dimension(469, 284));
      upperPanel.setOpaque(false);
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
      gridBagConstraints1.weightx = 0.5;
      gridBagConstraints1.weighty = 0.5;
      getContentPane().add(upperPanel, gridBagConstraints1);
      
      lowerPanel.setLayout(new java.awt.BorderLayout());
      
      lowerPanel.setBackground(java.awt.Color.lightGray);
      lowerPanel.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED), new javax.swing.border.LineBorder(java.awt.Color.black)));
      lowerPanel.setMinimumSize(new java.awt.Dimension(469, 284));
      lowerPanel.setPreferredSize(new java.awt.Dimension(469, 284));
      lowerPanel.setOpaque(false);
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 2;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.SOUTHWEST;
      gridBagConstraints1.weightx = 0.5;
      gridBagConstraints1.weighty = 0.5;
      getContentPane().add(lowerPanel, gridBagConstraints1);
      
      setJMenuBar(geotransMenuBar);
      pack();
  }//GEN-END:initComponents

  private void createFileHeaderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createFileHeaderActionPerformed
    new CreateFileHeaderDlg (this, true, currentDir, options).show ();
  }//GEN-LAST:event_createFileHeaderActionPerformed

  private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
    new AboutDlg(this, true).show();
  }//GEN-LAST:event_aboutMenuItemActionPerformed

  private void helpContentsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpContentsActionPerformed
   java.io.File helpFile = new java.io.File ("..");
   try
   {
       if (StartBrowser.isWindowsPlatform())
           StartBrowser.displayURL(this, "file:" + helpFile.getCanonicalPath() + "\\help\\contents.htm");
       else
           StartBrowser.displayURL(this, "file:" + helpFile.getCanonicalPath() + "/help/contents.htm");
   }
   catch(Exception e) 
   {
        jniStrtoval.displayErrorMsg(this, "Could not invoke browser");
   }   
  }//GEN-LAST:event_helpContentsActionPerformed

  private void lookAndFeelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lookAndFeelActionPerformed
    try
    {
        if (metalRadioButtonMenuItem.isSelected())
        {
            currLookAndFeel = "Java";
            javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
        }
        else if (unixRadioButtonMenuItem.isSelected())
        {
            currLookAndFeel = "Unix";
            javax.swing.UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
        }
        else if (windowsRadioButtonMenuItem.isSelected())
        {
            String osName = System.getProperty("os.name");
            if ((osName != null) && (osName.indexOf("Windows") != -1))
            {
                currLookAndFeel = "Windows";
                javax.swing.UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            }
            else
            {
                resetLookAndFeel();
                jniStrtoval.displayErrorMsg(this, "This option is only available on a Windows platform");
            }
        }
        javax.swing.SwingUtilities.updateComponentTreeUI(this);
        upper_mp.setLookAndFeel(currLookAndFeel);
        lower_mp.setLookAndFeel(currLookAndFeel);
    }
    catch (Exception e)
    {
        jniStrtoval.displayErrorMsg(this, e.getMessage());
    }

  }//GEN-LAST:event_lookAndFeelActionPerformed

  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit(0);
  }//GEN-LAST:event_exitForm

  /** Exit the Application in response to File menu - "exit" event.*/
  private void exitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitActionPerformed
    System.exit(0);
  }//GEN-LAST:event_exitActionPerformed

  /** Open a File for multi-point conversions. */  
  private void openActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openActionPerformed
    JNIFiomeths jniFiomeths = new JNIFiomeths();
    
    javax.swing.JFileChooser jChooser1 = new javax.swing.JFileChooser(currentDir.getDirectory());
    jChooser1.addChoosableFileFilter(new DATFileFilter()); 
    jChooser1.setSelectedFile(new java.io.File("*.dat"));
    int state = jChooser1.showOpenDialog(this);   
    if( state == javax.swing.JFileChooser.APPROVE_OPTION )
    {
        java.io.File file = jChooser1.getSelectedFile();
        currentDir.setDirectory(file.getAbsolutePath());
        if( file != null )
        {
            try
            {
                jniFiomeths.JNISetInputFilename(file.getPath());

                new FileDlg (this, true, currentDir, options, jniFiomeths).show ();
            }
            catch(GeotransError e)
            {
                jniStrtoval.displayErrorMsg(this, e.getMessage());
                jniFiomeths.JNICloseInputFile();
            }
            catch(JNIException e)
            {
                jniStrtoval.displayErrorMsg(this, e.getMessage());
                jniFiomeths.JNICloseInputFile();
            }
        }      
    }

  }//GEN-LAST:event_openActionPerformed

  /** Open "Format Options" dialog in response to Options menu - "Format" event. 
  *   Specifies output precision and angle measure (Latitude/Longitude/Orientation) 
  *   format in terms of units, range, sign and separator.*/  
  private void formatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_formatActionPerformed
    FormatOptionsDlg formatOptionsDlg = new FormatOptionsDlg(this, true, options); 
    formatOptionsDlg.show();
  }//GEN-LAST:event_formatActionPerformed

  /** Converts Lower Projection Coordinates to Upper Projection Coordinates. */  
  private void convertUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_convertUpActionPerformed
    boolean errorCode = false;

    try
    {
        lower_mp.setProjectionDir(IOValue.INPUT);
        lower_mp.setEngine();
        if(!lower_mp.JNIError() && !lower_mp.engineError())
        {
            upper_mp.setProjectionDir(IOValue.OUTPUT);
            upper_mp.setEngine();
            if(!upper_mp.JNIError() && !upper_mp.engineError())
                jniEngine.JNIConvert(ConversionState.INTERACTIVE);
            else
            {
                errorCode = true;
                upper_mp.showErrors(this);
            }
        }
        else
        {
            errorCode = true;
            lower_mp.showErrors(this);
        }
    }
    catch(GeotransError e)
    {
        errorCode = true;
        jniStrtoval.displayErrorMsg(this, e.getMessage());
    }
    catch(GeotransWarning e)
    {
        errorCode = false;
        jniStrtoval.displayWarningMsg(this, e.getMessage());
    }
    catch(JNIException e)
    {
        errorCode = true;
        jniStrtoval.displayErrorMsg(this, e.getMessage());
    }
    
    if (!errorCode)
    {
        upper_mp.getCoords(IOValue.OUTPUT);
        if(!upper_mp.JNIError() && !upper_mp.engineError())
        {
            upper_mp.reportAccuracy();
///            lower_mp.resetAccuracy();
        }
        else
            upper_mp.showErrors(this);
    }
  }//GEN-LAST:event_convertUpActionPerformed

  /** Converts Upper Projection Coordinates to Lower Projection Coordinates. */
  private void convertDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_convertDownActionPerformed
    boolean errorCode = false;

    try
    {
        upper_mp.setProjectionDir(IOValue.INPUT);
        upper_mp.setEngine();
        if(!upper_mp.JNIError() && !upper_mp.engineError())
        {
            lower_mp.setProjectionDir(IOValue.OUTPUT);
            lower_mp.setEngine();
            if(!lower_mp.JNIError() && !lower_mp.engineError())
                jniEngine.JNIConvert(ConversionState.INTERACTIVE);
            else
            {
                errorCode = true;
                lower_mp.showErrors(this);
            }
        }
        else
        {
            errorCode = true;
            upper_mp.showErrors(this);
        }
    }
    catch(GeotransError e)
    {
        errorCode = true;
        jniStrtoval.displayErrorMsg(this, e.getMessage());
    }
    catch(GeotransWarning e)
    {
        errorCode = false;
        jniStrtoval.displayWarningMsg(this, e.getMessage());
    }
    catch(JNIException e)
    {
        errorCode = true;
        jniStrtoval.displayErrorMsg(this, e.getMessage());
    }
    
    if(!errorCode)
    {   // no errors
        lower_mp.getCoords(IOValue.OUTPUT);
        if(!lower_mp.JNIError() && !lower_mp.engineError())
        {
///            upper_mp.resetAccuracy();
            lower_mp.reportAccuracy();
        }
        else
            lower_mp.showErrors(this);
    }
  }//GEN-LAST:event_convertDownActionPerformed

  private void deleteEllipsoidActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteEllipsoidActionPerformed
    // The DeleteDlg class is used for both Delete Ellipsoid and Delete Datum commands.
    new DeleteDlg(this, true, ListType.ELLIPSOID).show(); 
  }//GEN-LAST:event_deleteEllipsoidActionPerformed

  private void createEllipsoidActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createEllipsoidActionPerformed
    new CreateEllipsoidDlg(this, true).show(); 
  }//GEN-LAST:event_createEllipsoidActionPerformed

  private void deleteDatumActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteDatumActionPerformed
    // The DeleteDlg class is used for both Delete Ellipsoid and Delete Datum commands.
    DeleteDlg deleteDatum = new DeleteDlg(this, true, ListType.DATUM); 
    deleteDatum.show();
    upper_mp.deleteDatumFromList(deleteDatum.getIndex());
    lower_mp.deleteDatumFromList(deleteDatum.getIndex());
  }//GEN-LAST:event_deleteDatumActionPerformed

  private void createDatumActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createDatumActionPerformed
    new CreateDatumDlg(this, true).show(); 
    upper_mp.addDatumToList();
    lower_mp.addDatumToList();
  }//GEN-LAST:event_createDatumActionPerformed

  private void editButtonMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_editButtonMouseEntered
    prevFocus = getFocusOwner();
  }//GEN-LAST:event_editButtonMouseEntered

  private void pasteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pasteActionPerformed
    java.awt.Component focus = getFocusOwner();
    if (focus instanceof javax.swing.text.JTextComponent)
        ((javax.swing.text.JTextComponent)focus).paste();    
    else if (focus == pasteButton)
        if (prevFocus instanceof javax.swing.text.JTextComponent)
            ((javax.swing.text.JTextComponent)prevFocus).paste();
  }//GEN-LAST:event_pasteActionPerformed

  private void cutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cutActionPerformed
    java.awt.Component focus = getFocusOwner();
    if (focus instanceof javax.swing.text.JTextComponent)
        ((javax.swing.text.JTextComponent)focus).cut();   
    else if (focus == cutButton)
        if (prevFocus instanceof javax.swing.text.JTextComponent)
            ((javax.swing.text.JTextComponent)prevFocus).cut();    
  }//GEN-LAST:event_cutActionPerformed

  private void copyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_copyActionPerformed
    java.awt.Component focus = getFocusOwner();
    if (focus instanceof javax.swing.text.JTextComponent)
        ((javax.swing.text.JTextComponent)focus).copy();
    else if (focus == copyButton)
        if (prevFocus instanceof javax.swing.text.JTextComponent)
            ((javax.swing.text.JTextComponent)prevFocus).copy();        
  }//GEN-LAST:event_copyActionPerformed

  
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    new Geotrans().show ();
    return;
  }
  
  // Test if a 3D conversion is possible
  // If it is, enable the geodetic height fields
  // If it is not, set the geodetic height fields to read only
  public void check3DConversion()
  {
      boolean _3dConversion = false;
      if (upper_mp.getProjectionType() == CoordinateTypes.GEODETIC)
      {
        if ((lower_mp.getProjectionType() == CoordinateTypes.GEODETIC) || (lower_mp.getProjectionType() == CoordinateTypes.GEOCENTRIC) || (lower_mp.getProjectionType() == CoordinateTypes.LOCCART))
        {
            upper_mp.enableEllipsoidHeightButton(true);
            upper_mp.enableMSLHeightButton(true);
            if (upper_mp.getGeodeticHeight() != HeightType.NO_HEIGHT)
            {
               _3dConversion = true;
                upper_mp.setHeightFieldEditable(true);
            }
            else
                upper_mp.setHeightFieldEditable(false);
            
            if (lower_mp.getProjectionType() == CoordinateTypes.GEODETIC)
            {
                lower_mp.enableEllipsoidHeightButton(true);
                lower_mp.enableMSLHeightButton(true);
                if (lower_mp.getGeodeticHeight() != HeightType.NO_HEIGHT)
                    lower_mp.setHeightFieldEditable(true);
                else
                {
                    _3dConversion = false;
                    lower_mp.setHeightFieldEditable(false);
                }
            }
        }
        else
        {
            upper_mp.enableEllipsoidHeightButton(false);
            upper_mp.enableMSLHeightButton(false);
            upper_mp.selectNoHeightButton();
            upper_mp.setHeightFieldEditable(false);
        }
      }
      else if (lower_mp.getProjectionType() == CoordinateTypes.GEODETIC)
      {
        if ((upper_mp.getProjectionType() == CoordinateTypes.GEOCENTRIC) || (upper_mp.getProjectionType() == CoordinateTypes.LOCCART))
        {
            lower_mp.enableEllipsoidHeightButton(true);
            lower_mp.enableMSLHeightButton(true);
            if (lower_mp.getGeodeticHeight() != HeightType.NO_HEIGHT)
            {
                _3dConversion = true;
                lower_mp.setHeightFieldEditable(true);
            }
            else
                lower_mp.setHeightFieldEditable(false);
        }
        else
        {
            lower_mp.enableEllipsoidHeightButton(false);
            lower_mp.enableMSLHeightButton(false);
            lower_mp.selectNoHeightButton();
            lower_mp.setHeightFieldEditable(false);
        }
      }
      else if (((upper_mp.getProjectionType() == CoordinateTypes.GEOCENTRIC) || (upper_mp.getProjectionType() == CoordinateTypes.LOCCART)) &&
               ((lower_mp.getProjectionType() == CoordinateTypes.GEOCENTRIC) || (lower_mp.getProjectionType() == CoordinateTypes.LOCCART)))
        _3dConversion = true;

      upper_mp.updateSrcErrors(_3dConversion);
      lower_mp.updateSrcErrors(_3dConversion);
  }
  
// Creates projection panels, coordinate & parameter objects, 
// and initializes engine via JNI functions.
  private void initialize(){  
    boolean error = false;
    options = new jOptions();
    
    try
    {
        jniEngine.JNIInitializeEngine(); // JNI; calls Initialize_Engine.

        upper_mp = new MasterPanel(ConversionState.INTERACTIVE, IOValue.INPUT, options);
        if (upper_mp == null)
        {
            jniStrtoval.displayErrorMsg(this, "Unable to initialize GEOTRANS");
            System.exit (0);
        }
        
        lower_mp = new MasterPanel(ConversionState.INTERACTIVE, IOValue.OUTPUT, options);
        if (lower_mp == null)
        {
            jniStrtoval.displayErrorMsg(this, "Unable to initialize GEOTRANS");
            System.exit (0);
        }
        
        upper_mp.setParent(this);
        lower_mp.setParent(this);
        
        check3DConversion();
        
        upperPanel.add( upper_mp, java.awt.BorderLayout.CENTER); 
        lowerPanel.add( lower_mp, java.awt.BorderLayout.CENTER ); 
    }
    catch(GeotransError e)
    {
        jniStrtoval.displayErrorMsg(this, e.getMessage());
        error = true;
    }
    catch (java.lang.UnsatisfiedLinkError e)
    {
        jniStrtoval.displayErrorMsg(this, "Unsatisfied Link Error: " + e.getMessage());
        error = true;
    }
    
    if (error)
        System.exit (0);
  }
  
  private void resetLookAndFeel()
  {
      if (currLookAndFeel.equals("Java"))
        metalRadioButtonMenuItem.setSelected(true);
      else if (currLookAndFeel.equals("Unix"))
        unixRadioButtonMenuItem.setSelected(true);
      else if (currLookAndFeel.equals("Windows"))
        windowsRadioButtonMenuItem.setSelected(true);
  }
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JMenuBar geotransMenuBar;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JMenuItem openMenuItem;
  private javax.swing.JMenuItem createFileHeaderMenuItem;
  private javax.swing.JSeparator fileMenuSeparator;
  private javax.swing.JMenuItem exitMenuItem;
  private javax.swing.JMenu editMenu;
  private javax.swing.JMenuItem cutMenuItem;
  private javax.swing.JMenuItem copyMenuItem;
  private javax.swing.JMenuItem pasteMenuItem;
  private javax.swing.JMenu optionsMenu;
  private javax.swing.JMenuItem formatMenuItem;
  private javax.swing.JMenu lookAndFeelMenu;
  private javax.swing.JRadioButtonMenuItem metalRadioButtonMenuItem;
  private javax.swing.JRadioButtonMenuItem unixRadioButtonMenuItem;
  private javax.swing.JRadioButtonMenuItem windowsRadioButtonMenuItem;
  private javax.swing.JMenu datumMenu;
  private javax.swing.JMenuItem createDatumMenuItem;
  private javax.swing.JMenuItem deleteDatumMenuItem;
  private javax.swing.JMenu ellipsoidMenu;
  private javax.swing.JMenuItem createEllipsoidMenuItem;
  private javax.swing.JMenuItem deleteEllipsoidMenuItem;
  private javax.swing.JMenu convertMenu;
  private javax.swing.JMenuItem convertDownMenuItem;
  private javax.swing.JSeparator convertMenuSeparator;
  private javax.swing.JMenuItem convertUpMenuItem;
  private javax.swing.JMenu helpMenu;
  private javax.swing.JMenuItem contentsMenuItem;
  private javax.swing.JSeparator helpMenuSeparator;
  private javax.swing.JMenuItem aboutMenuItem;
  private javax.swing.JToolBar geotransToolBar;
  private javax.swing.JButton cutButton;
  private javax.swing.JButton copyButton;
  private javax.swing.JButton pasteButton;
  private javax.swing.JButton formatButton;
  private javax.swing.JSeparator geotransToolBarSeparator;
  private javax.swing.JButton convertDownButton;
  private javax.swing.JButton convertUpButton;
  private javax.swing.JPanel upperPanel;
  private javax.swing.JPanel lowerPanel;
  // End of variables declaration//GEN-END:variables

} //end of Geotrans class.

