// mainfrm.cpp : implementation of the CMainFrame class
//

#include <direct.h>

#include "stdafx.h"
#include "geotrans.h"
#include "engine.h"

#include "fiomeths.h"   
#include "filevw.h"
#include "progress.h"
#include "datumvw.h"
#include "ellipsevw.h"
#include "delellipvw.h"
#include "deldatumvw.h"

#include "mainfrm.h"
#include "geotrdoc.h"
#include "geotrvw.h"

#include "mastervw.h"
#include "convertvw.h"

#include "strtoval.h"

#ifdef _DEBUG
  #undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_HELP_HELP, OnHelpHelp)
	ON_COMMAND(ID_OPTIONS_COLORS_BACKGROUND, OnOptionsColorsBackground)
	ON_COMMAND(ID_OPTIONS_COLORS_TEXT, OnOptionsColorsText)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_SIGNHEMISPHERE_NSEW, OnOptionsGeodeticformatSignhemisphereNsew)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_SIGNHEMISPHERE_PLUS_MINUS, OnOptionsGeodeticformatSignhemispherePlusMinus)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_UNITS_DEGREESMINUTESSECONDS, OnOptionsGeodeticformatUnitsDegreesminutesseconds)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_UNITS_DEGREESMINUTES, OnOptionsGeodeticformatUnitsDegreesminutes)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_UNITS_DEGREE, OnOptionsGeodeticformatUnitsDegree)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_SIGNHEMISPHERE_NSEW, OnUpdateOptionsGeodeticformatSignhemisphereNsew)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_SIGNHEMISPHERE_PLUS_MINUS, OnUpdateOptionsGeodeticformatSignhemispherePlusMinus)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_UNITS_DEGREE, OnUpdateOptionsGeodeticformatUnitsDegree)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_UNITS_DEGREESMINUTES, OnUpdateOptionsGeodeticformatUnitsDegreesminutes)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_UNITS_DEGREESMINUTESSECONDS, OnUpdateOptionsGeodeticformatUnitsDegreesminutesseconds)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_OPTIONS_PRECISION_100000M, OnOptionsPrecision100000m)
	ON_COMMAND(ID_OPTIONS_PRECISION_10000M, OnOptionsPrecision10000m)
	ON_COMMAND(ID_OPTIONS_PRECISION_1000M, OnOptionsPrecision1000m)
	ON_COMMAND(ID_OPTIONS_PRECISION_100M, OnOptionsPrecision100m)
	ON_COMMAND(ID_OPTIONS_PRECISION_10M, OnOptionsPrecision10m)
	ON_COMMAND(ID_OPTIONS_PRECISION_1M, OnOptionsPrecision1m)
	ON_COMMAND(ID_OPTIONS_PRECISION_PNT1M, OnOptionsPrecisionPnt1m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_100000M, OnUpdateOptionsPrecision100000m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_10000M, OnUpdateOptionsPrecision10000m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_1000M, OnUpdateOptionsPrecision1000m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_100M, OnUpdateOptionsPrecision100m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_10M, OnUpdateOptionsPrecision10m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_1M, OnUpdateOptionsPrecision1m)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_PNT1M, OnUpdateOptionsPrecisionPnt1m)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_SEPARATOR_BLANKSPACE, OnOptionsGeodeticformatSeparatorBlankspace)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_SEPARATOR_BLANKSPACE, OnUpdateOptionsGeodeticformatSeparatorBlankspace)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_SEPARATOR_SLASH, OnUpdateOptionsGeodeticformatSeparatorSlash)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_SEPARATOR_SLASH, OnOptionsGeodeticformatSeparatorSlash)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_SEPARATOR_COLON, OnOptionsGeodeticformatSeparatorColon)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_SEPARATOR_COLON, OnUpdateOptionsGeodeticformatSeparatorColon)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_LONGITUDERANGE_180180, OnUpdateOptionsGeodeticformatLongituderange180180)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_LONGITUDERANGE_180180, OnOptionsGeodeticformatLongituderange180180)
	ON_COMMAND(ID_OPTIONS_GEODETICFORMAT_LONGITUDERANGE_0360, OnOptionsGeodeticformatLongituderange0360)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_GEODETICFORMAT_LONGITUDERANGE_0360, OnUpdateOptionsGeodeticformatLongituderange0360)
	ON_COMMAND(ID_OPTIONS_PRECISION_1CM, OnOptionsPrecision1cm)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_1CM, OnUpdateOptionsPrecision1cm)
	ON_COMMAND(ID_OPTIONS_PRECISION_1MM, OnOptionsPrecision1mm)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PRECISION_1MM, OnUpdateOptionsPrecision1mm)
	ON_COMMAND(ID_DATUM_CREATE, OnDatumCreate)
	ON_COMMAND(ID_DATUM_DELETE, OnDatumDelete)
	ON_COMMAND(ID_ELLIPSOID_CREATE, OnEllipsoidCreate)
	ON_COMMAND(ID_ELLIPSOID_DELETE, OnEllipsoidDelete)
  ON_COMMAND(ID_CONVERT_TO_LOWER, OnConvertUppertoLower)
  ON_COMMAND(ID_CONVERT_TO_UPPER, OnConvertLowertoUpper)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
  // same order as in the bitmap 'toolbar.bmp'
  ID_FILE_NEW,
  ID_FILE_OPEN,
  ID_FILE_SAVE,
  ID_SEPARATOR,
  ID_EDIT_CUT,
  ID_EDIT_COPY,
  ID_EDIT_PASTE,
  ID_SEPARATOR,
  ID_FILE_PRINT,
  ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
  ID_SEPARATOR,           // status line indicator
  ID_INDICATOR_CAPS,
  ID_INDICATOR_NUM,
  ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
  // TODO: add member initialization code here
  LOGBRUSH lb;
  long error_code;
  precis = Tenth_of_Second;
  geodetic_hemiFlag = NSEW;
  geodetic_format = DMS;
  Set_Separator(' ');
  m_pSplitter = new CSplitterWnd();
  lb.lbStyle = BS_SOLID;
  //    background_color = RGB(128,128,128);
  background_color = RGB(192,192,192);
  lb.lbColor = background_color;
  lb.lbHatch = HS_BDIAGONAL;
  background_brush = CreateBrushIndirect(&lb);
  text_color = RGB(0,0,0);
  error_code = Initialize_Engine();
  if (error_code)
  {
    AfxMessageBox("Error initializing GEOTRANS engine!",MB_OK | MB_ICONEXCLAMATION);
  }
  Set_Precision(precis);
  getcwd(current_dir, 256);
}

CMainFrame::~CMainFrame()
{
  delete m_pSplitter;
  DeleteObject((HGDIOBJ)background_brush);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  lpCreateStruct->cx = 350;
  lpCreateStruct->cy = 300;
  lpCreateStruct->x = 50;
  lpCreateStruct->y = 50;

  if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
    return -1;

  if (!m_wndStatusBar.Create(this) ||
      !m_wndStatusBar.SetIndicators(indicators,
                                    sizeof(indicators)/sizeof(UINT)))
  {
    TRACE("Failed to create status bar\n");
    return -1;      // fail to create
  }
  return 0;
}


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
  int width = 520;// 539
  int height = 540;
 	
  BOOL rtn = m_pSplitter->CreateStatic(this,3,1);

  rtn |= m_pSplitter->CreateView(0,0,RUNTIME_CLASS(CMasterView),
                                 CSize( 20,265),pContext);

  rtn |= m_pSplitter->CreateView(1,0,RUNTIME_CLASS(CConvertView),
						CSize(25,30),pContext);

  rtn |= m_pSplitter->CreateView(2,0,RUNTIME_CLASS(CMasterView),
						CSize(280,265),pContext);

  CWnd* upper_p = m_pSplitter->GetPane(0,0); // upper view
  CWnd* lower_p = m_pSplitter->GetPane(2,0); // lower view

  ((CMasterView*)upper_p)->FillListBox();
  ((CMasterView*)lower_p)->FillListBox();

  ((CMasterView*)upper_p)->FillSourcesListBox();
  ((CMasterView*)lower_p)->FillSourcesListBox();

  ((CMasterView*)upper_p)->SetFormat(geodetic_format);
  ((CMasterView*)lower_p)->SetFormat(geodetic_format);

  ((CMasterView*)upper_p)->SetHemiFlag(geodetic_hemiFlag);
  ((CMasterView*)lower_p)->SetHemiFlag(geodetic_hemiFlag);

  ((CMasterView*)upper_p)->FillProjectionList(Geodetic);
  ((CMasterView*)lower_p)->FillProjectionList(UTM);

  CWnd* convert_p = m_pSplitter->GetPane(1,0); // convert view
	// These two functions of convertvw setup pointers to the forms.
  ((CConvertView*)convert_p)->SetUpperPointer((CMasterView*)upper_p);
  ((CConvertView*)convert_p)->SetLowerPointer((CMasterView*)lower_p);
 
#ifdef WIN32
  width = 460;
  height = 640; // dimensions of outer frame
#endif
  SetWindowPos(&wndNoTopMost,150,20,width,height,SWP_NOZORDER);
  return rtn;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
  CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
  CFrameWnd::Dump(dc);
}

#endif //_DEBUG


HBRUSH CMainFrame::GetBackgroundBrush()
{
  return background_brush;
}

COLORREF CMainFrame::GetBackgroundColor()
{
  return background_color;
}

COLORREF CMainFrame::GetTextColor()
{
  return text_color;
}

void OpenObject( char* sObjectPath  )
{
  ShellExecute( 0, NULL, ( sObjectPath ),
                 NULL, NULL, SW_NORMAL );
}

 /////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnHelpHelp()
{
  chdir(current_dir);
  chdir("../help");

  ShellExecute( 0, NULL, "contents.htm",NULL, NULL, SW_NORMAL );

}


void CMainFrame::GetAccuracy()
{
  char str[15];
  double ce90, le90, se90;
  Get_Conversion_Errors (Interactive, &ce90, &le90, &se90);
  if (ce90 == -1.0)
    m_ce90 = "Unk";
  else
  {
    sprintf(str,"%1.0f",ce90);
    m_ce90 = str;
  }
  if (le90 == -1.0)
    m_le90 = "Unk";
  else
  {
    sprintf(str,"%1.0f",le90);
    m_le90 = str;
  }
  if (se90 == -1.0)
    m_se90 = "Unk";
  else
  {
    sprintf(str,"%1.0f",se90);
    m_se90 = str;
  }
}


void CMainFrame::OnOptionsColorsBackground()
{
  m_wndColorDlg = new CColorDialog(background_color);
  LOGBRUSH lb;

  if (m_wndColorDlg->DoModal() != IDCANCEL)
  {
    background_color = m_wndColorDlg->GetColor();
    lb.lbStyle = BS_SOLID;
    lb.lbColor = background_color;
    lb.lbHatch = HS_BDIAGONAL;
    DeleteObject((HGDIOBJ)background_brush);
    background_brush = CreateBrushIndirect(&lb);
    RedrawWindow();
  }
  delete m_wndColorDlg;
}

void CMainFrame::OnOptionsColorsText()
{
  m_wndColorDlg = new CColorDialog(text_color);

  if (m_wndColorDlg->DoModal() != IDCANCEL)
  {
    text_color = m_wndColorDlg->GetColor();
    RedrawWindow();
  }
  delete m_wndColorDlg;   
}


void CMainFrame::OnOptionsGeodeticformatSignhemisphereNsew()
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  geodetic_hemiFlag = NSEW;
  ((CMasterView*)upper_pointer)->SetHemiFlag(geodetic_hemiFlag);
  ((CMasterView*)lower_pointer)->SetHemiFlag(geodetic_hemiFlag);
}

void CMainFrame::OnOptionsGeodeticformatSignhemispherePlusMinus()
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  geodetic_hemiFlag = PLUS_MINUS;
  ((CMasterView*)upper_pointer)->SetHemiFlag(geodetic_hemiFlag);
  ((CMasterView*)lower_pointer)->SetHemiFlag(geodetic_hemiFlag);
}

void CMainFrame::OnOptionsGeodeticformatUnitsDegreesminutesseconds()
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  geodetic_format = DMS;
  ((CMasterView*)upper_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)lower_pointer)->SetFormat(geodetic_format);
}

void CMainFrame::OnOptionsGeodeticformatUnitsDegreesminutes()
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  geodetic_format = DM;
  ((CMasterView*)upper_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)lower_pointer)->SetFormat(geodetic_format);
}

void CMainFrame::OnOptionsGeodeticformatUnitsDegree()
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  geodetic_format = DD;
  ((CMasterView*)upper_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)lower_pointer)->SetFormat(geodetic_format);
}

void CMainFrame::OnUpdateOptionsGeodeticformatSignhemisphereNsew(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(geodetic_hemiFlag == NSEW);
}

void CMainFrame::OnUpdateOptionsGeodeticformatSignhemispherePlusMinus(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(geodetic_hemiFlag == PLUS_MINUS);
}

void CMainFrame::OnUpdateOptionsGeodeticformatUnitsDegree(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(geodetic_format == DD);
}

void CMainFrame::OnUpdateOptionsGeodeticformatUnitsDegreesminutes(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(geodetic_format == DM);
}

void CMainFrame::OnUpdateOptionsGeodeticformatUnitsDegreesminutesseconds(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(geodetic_format == DMS);
}

void CMainFrame::OnFileOpen()
{
  Progress *p_Progress;
  CString filename;
  FIO_Status file_error;
  char err_str[256];

  p_fileOpenDlg = new CFileDialog(TRUE,"dat","*.dat", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Data Files (*.dat)|*.dat|All Files (*.*)|*.*||");
  if (p_fileOpenDlg->DoModal() != IDCANCEL)
  {
    filename = p_fileOpenDlg->GetPathName();
    file_error = Set_Input_Filename(filename);
    if (file_error)
    {
      char temp_err_str[256];
      sprintf(err_str,"Error:\n");
      Get_File_Error_String(file_error,temp_err_str);
      strcat(err_str, temp_err_str);
      AfxMessageBox(err_str,MB_OK | MB_ICONEXCLAMATION);
	    Close_Input_File();
    }
    else
    {
      p_fileProcDlg = new CFileProcDlg();
      p_fileProcDlg->Set_Current_Directory(current_dir);
      p_fileProcDlg->SetFormat
          ( (geodetic_hemiFlag == NSEW) ? TRUE : FALSE,
            (geodetic_format != DD) ? TRUE : FALSE,
            (geodetic_format == DMS) ? TRUE : FALSE);
      Use_NSEW( (geodetic_hemiFlag == NSEW) ? TRUE : FALSE);
      Use_Minutes( (geodetic_format != DD) ? TRUE : FALSE);
      Use_Seconds( (geodetic_format == DMS) ? TRUE : FALSE);

      if (p_fileProcDlg->DoModal() != IDCANCEL)
      {
        p_fileSaveDlg = new CFileDialog(FALSE,"dat","*.dat",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Data Files (*.dat)|*.dat|All Files (*.*)|*.*||");

        if (p_fileSaveDlg->DoModal() != IDCANCEL)
        {
          filename = p_fileSaveDlg->GetPathName();
          if (Set_Output_Filename(filename))
		      {
            AfxMessageBox("Error opening output file.",MB_OK | MB_ICONEXCLAMATION);
		  	    Close_Input_File();
		      }
          else
          {
            p_Progress = new Progress(this);
            if (p_Progress->DoModal() == IDCANCEL)
            {
              Close_Input_File();
              Close_Output_File();
            }
          }
        }
		    else
		      Close_Input_File();
		    delete p_fileSaveDlg;
      }
	    else
		    Close_Input_File();
      delete p_fileProcDlg;   
    }
  }
  delete p_fileOpenDlg;
}

void CMainFrame::OnOptionsPrecision100000m()
{
  precis = Degree;
  Set_Precision(Degree);
  Set_Lat_Long_Precision(Degree);
}

void CMainFrame::OnOptionsPrecision10000m()
{
  precis = Ten_Minutes;
  Set_Precision(Ten_Minutes);
  Set_Lat_Long_Precision(Ten_Minutes);
}

void CMainFrame::OnOptionsPrecision1000m()
{
  precis = Minute;
  Set_Precision(Minute);
  Set_Lat_Long_Precision(Minute);
}

void CMainFrame::OnOptionsPrecision100m()
{
  precis = Ten_Seconds;
  Set_Precision(Ten_Seconds);
  Set_Lat_Long_Precision(Ten_Seconds);
}

void CMainFrame::OnOptionsPrecision10m()
{
  precis = Second;
  Set_Precision(Second);
  Set_Lat_Long_Precision(Second);
}

void CMainFrame::OnOptionsPrecision1m()
{
  precis = Tenth_of_Second;
  Set_Precision(Tenth_of_Second);
  Set_Lat_Long_Precision(Tenth_of_Second);
}

void CMainFrame::OnOptionsPrecisionPnt1m()
{
  AfxMessageBox("Warning:  Output accuracy is limited to ~1m",MB_OK | MB_ICONEXCLAMATION);
  precis = Hundredth_of_Second;
  Set_Precision(Hundredth_of_Second);
  Set_Lat_Long_Precision(Hundredth_of_Second);
}

void CMainFrame::OnOptionsPrecision1cm() 
{
  AfxMessageBox("Warning:  Output accuracy is limited to ~1m",MB_OK | MB_ICONEXCLAMATION);
  precis = Thousandth_of_Second;
  Set_Precision(Thousandth_of_Second);
  Set_Lat_Long_Precision(Thousandth_of_Second);
}

void CMainFrame::OnOptionsPrecision1mm() 
{
  AfxMessageBox("Warning:  Output accuracy is limited to ~1m",MB_OK | MB_ICONEXCLAMATION);
  precis = Ten_Thousandth_of_Second;
  Set_Precision(Ten_Thousandth_of_Second);
  Set_Lat_Long_Precision(Ten_Thousandth_of_Second);
}

void CMainFrame::OnUpdateOptionsPrecision100000m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Degree);
}

void CMainFrame::OnUpdateOptionsPrecision10000m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Ten_Minutes);
}

void CMainFrame::OnUpdateOptionsPrecision1000m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Minute);
}

void CMainFrame::OnUpdateOptionsPrecision100m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Ten_Seconds);
}

void CMainFrame::OnUpdateOptionsPrecision10m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Second);
}

void CMainFrame::OnUpdateOptionsPrecision1m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Tenth_of_Second);
}

void CMainFrame::OnUpdateOptionsPrecisionPnt1m(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(precis == Hundredth_of_Second);
}

void CMainFrame::OnUpdateOptionsPrecision1cm(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck(precis == Thousandth_of_Second);
}

void CMainFrame::OnUpdateOptionsPrecision1mm(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck(precis == Ten_Thousandth_of_Second);
}

void CMainFrame::OnOptionsGeodeticformatSeparatorBlankspace()
{
  Set_Separator(' ');
}

void CMainFrame::OnOptionsGeodeticformatSeparatorSlash()
{
  Set_Separator('/');
}

void CMainFrame::OnOptionsGeodeticformatSeparatorColon()
{
  Set_Separator(':');
}

void CMainFrame::OnUpdateOptionsGeodeticformatSeparatorBlankspace(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(Get_Separator() == ' ');
}

void CMainFrame::OnUpdateOptionsGeodeticformatSeparatorSlash(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(Get_Separator() == '/');
}

void CMainFrame::OnUpdateOptionsGeodeticformatSeparatorColon(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(Get_Separator() == ':');
}

void CMainFrame::OnUpdateOptionsGeodeticformatLongituderange180180(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(Get_Long_Range() == _180_180);
}

void CMainFrame::OnOptionsGeodeticformatLongituderange180180()
{
  Set_Long_Range(_180_180);
}

void CMainFrame::OnOptionsGeodeticformatLongituderange0360()
{
  Set_Long_Range(_0_360);
}

void CMainFrame::OnUpdateOptionsGeodeticformatLongituderange0360(CCmdUI* pCmdUI)
{
  pCmdUI->SetCheck(Get_Long_Range() == _0_360);
}

void CMainFrame::OnDatumCreate() 
{
  p_DatumDlg = new CDatumView();
  p_DatumDlg->DoModal();
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);
  ((CMasterView*)upper_pointer)->FillListBox();
  ((CMasterView*)lower_pointer)->FillListBox();
  delete p_DatumDlg;
}

void CMainFrame::OnDatumDelete() 
{
  p_DeleteDatumDlg = new CDeleteDatumView();
  p_DeleteDatumDlg->DoModal();
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);
  ((CMasterView*)upper_pointer)->FillListBox();
  ((CMasterView*)lower_pointer)->FillListBox();
  delete p_DeleteDatumDlg;
}

void CMainFrame::OnEllipsoidCreate() 
{
  p_EllipsoidDlg = new CEllipsoidView();
  p_EllipsoidDlg->DoModal();
  delete p_EllipsoidDlg;  	
}

void CMainFrame::OnEllipsoidDelete() 
{
  p_DeleteEllipsoidDlg = new CDeleteEllipsoid();
  p_DeleteEllipsoidDlg->DoModal();
  delete p_DeleteEllipsoidDlg;  
}


void CMainFrame::OnConvertUppertoLower() 
{

  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  ((CMasterView*)upper_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)upper_pointer)->SetHemiFlag(geodetic_hemiFlag);
  ((CMasterView*)lower_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)lower_pointer)->SetHemiFlag(geodetic_hemiFlag);

  ((CConvertView*)upper_pointer)->SetUpperPointer((CMasterView*)upper_pointer);
  ((CConvertView*)upper_pointer)->SetLowerPointer((CMasterView*)lower_pointer);
  ((CConvertView*)upper_pointer)->OnConvertUppertoLower();

}


void CMainFrame::OnConvertLowertoUpper() 
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);

  ((CMasterView*)upper_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)upper_pointer)->SetHemiFlag(geodetic_hemiFlag);
  ((CMasterView*)lower_pointer)->SetFormat(geodetic_format);
  ((CMasterView*)lower_pointer)->SetHemiFlag(geodetic_hemiFlag);

  ((CConvertView*)lower_pointer)->SetUpperPointer((CMasterView*)upper_pointer);
  ((CConvertView*)lower_pointer)->SetLowerPointer((CMasterView*)lower_pointer);
  ((CConvertView*)lower_pointer)->OnConvertLowertoUpper();

}

CMasterView* CMainFrame::GetUpperView() 
{
  CWnd* upper_pointer = m_pSplitter->GetPane(0,0);
  return ((CMasterView*)upper_pointer);
}

CMasterView* CMainFrame::GetLowerView() 
{
  CWnd* lower_pointer = m_pSplitter->GetPane(2,0);
  return ((CMasterView*)lower_pointer);
}

void CMainFrame::Check_3D_Conversion()
{
  bool _3dConversion = false;
  CWnd *pWnd;
  CMasterView* upper_view = (CMasterView*)m_pSplitter->GetPane(0,0);
  CMasterView* lower_view = (CMasterView*)m_pSplitter->GetPane(2,0);

  if (upper_view->type == Geodetic)
  {
    if ((lower_view->type == Geodetic) || (lower_view->type == Geocentric) || (lower_view->type == Local_Cartesian))
    {
	    pWnd = upper_view->GetDlgItem(IDC_MSL_HEIGHT);
        ((CEdit*)pWnd)->EnableWindow(TRUE);
	    pWnd = upper_view->GetDlgItem(IDC_ELLIPSOID_HEIGHT);
        ((CEdit*)pWnd)->EnableWindow(TRUE);

      if (upper_view->GeodeticHeight() != No_Height)
      {
        _3dConversion = true;
        pWnd = upper_view->GetDlgItem(IDC_EDIT9);
        ((CEdit*)pWnd)->SetReadOnly(FALSE);
      }
      else
      {
        pWnd = upper_view->GetDlgItem(IDC_EDIT9);
        ((CEdit*)pWnd)->SetReadOnly(TRUE);
      }

      if (lower_view->type == Geodetic)
      {
	      pWnd = lower_view->GetDlgItem(IDC_MSL_HEIGHT);
          ((CEdit*)pWnd)->EnableWindow(TRUE);
	      pWnd = lower_view->GetDlgItem(IDC_ELLIPSOID_HEIGHT);
          ((CEdit*)pWnd)->EnableWindow(TRUE);
        if (lower_view->GeodeticHeight() != No_Height)
        {
          pWnd = lower_view->GetDlgItem(IDC_EDIT9);
          ((CEdit*)pWnd)->SetReadOnly(FALSE);
        }
        else
        {
          _3dConversion = false;
          pWnd = lower_view->GetDlgItem(IDC_EDIT9);
          ((CEdit*)pWnd)->SetReadOnly(TRUE);
        }
      }
    }
    else
    {
	    pWnd = upper_view->GetDlgItem(IDC_MSL_HEIGHT);
        ((CButton*)pWnd)->SetCheck(FALSE);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
	    pWnd = upper_view->GetDlgItem(IDC_ELLIPSOID_HEIGHT);
        ((CButton*)pWnd)->SetCheck(FALSE);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
	    pWnd = upper_view->GetDlgItem(IDC_NO_HEIGHT);
        ((CButton*)pWnd)->SetCheck(TRUE);
      upper_view->SetGeodeticHeight(No_Height);
      pWnd = upper_view->GetDlgItem(IDC_EDIT9);
      ((CEdit*)pWnd)->SetReadOnly(TRUE);
    }
  }
  else if (lower_view->type == Geodetic)
  {
    if ((upper_view->type == Geocentric) || (upper_view->type == Local_Cartesian)) 
    {
	    pWnd = lower_view->GetDlgItem(IDC_MSL_HEIGHT);
        ((CEdit*)pWnd)->EnableWindow(TRUE);
	    pWnd = lower_view->GetDlgItem(IDC_ELLIPSOID_HEIGHT);
        ((CEdit*)pWnd)->EnableWindow(TRUE);


      if (lower_view->GeodeticHeight() != No_Height)
      {
        _3dConversion = true;
        pWnd = lower_view->GetDlgItem(IDC_EDIT9);
        ((CEdit*)pWnd)->SetReadOnly(FALSE);
      }
      else
      {
        pWnd = lower_view->GetDlgItem(IDC_EDIT9);
        ((CEdit*)pWnd)->SetReadOnly(TRUE);
      }
    }
    else
    {
	    pWnd = lower_view->GetDlgItem(IDC_MSL_HEIGHT);
        ((CButton*)pWnd)->SetCheck(FALSE);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
	    pWnd = lower_view->GetDlgItem(IDC_ELLIPSOID_HEIGHT);
        ((CButton*)pWnd)->SetCheck(FALSE);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
	    pWnd = lower_view->GetDlgItem(IDC_NO_HEIGHT);
        ((CButton*)pWnd)->SetCheck(TRUE);
      lower_view->SetGeodeticHeight(No_Height);
      pWnd = lower_view->GetDlgItem(IDC_EDIT9);
      ((CEdit*)pWnd)->SetReadOnly(TRUE);
    }
  }
  else if (((upper_view->type == Geocentric) || (upper_view->type == Local_Cartesian)) &&
        ((lower_view->type == Geocentric) || (lower_view->type == Local_Cartesian)))
      _3dConversion = true;

  if (_3dConversion)
  {
 	    pWnd = upper_view->GetDlgItem(ID_LE90);
        ((CEdit*)pWnd)->EnableWindow(TRUE);
 	    pWnd = upper_view->GetDlgItem(ID_SE90);
        ((CEdit*)pWnd)->EnableWindow(TRUE);
 	    pWnd = lower_view->GetDlgItem(ID_LE90);
        ((CEdit*)pWnd)->EnableWindow(TRUE);
 	    pWnd = lower_view->GetDlgItem(ID_SE90);
        ((CEdit*)pWnd)->EnableWindow(TRUE);
  }
  else
  {
 	    pWnd = upper_view->GetDlgItem(ID_LE90);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
 	    pWnd = upper_view->GetDlgItem(ID_SE90);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
 	    pWnd = lower_view->GetDlgItem(ID_LE90);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
 	    pWnd = lower_view->GetDlgItem(ID_SE90);
        ((CEdit*)pWnd)->EnableWindow(FALSE);
  }

  upper_view->UpdateSrcErrors(_3dConversion);
  lower_view->UpdateSrcErrors(_3dConversion);

}
