// mainfrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

class CMasterView;

class CMainFrame : public CFrameWnd
{
private:
    int geodetic_format;
    int geodetic_hemiFlag;
    HBRUSH background_brush;
    COLORREF background_color;
    COLORREF text_color;
    Coordinate_Type top_frame,bottom_frame;
    CDialogBar m_wndDialogBar;
	//CDialogBar m_fileDialog;

	  CString m_ce90;
	  CString m_le90;
	  CString m_se90;
    CColorDialog* m_wndColorDlg;
    CFileProcDlg* p_fileProcDlg;
    CFileDialog* p_fileOpenDlg;
    CFileDialog* p_fileSaveDlg;
    CDatumView* p_DatumDlg;
    CEllipsoidView* p_EllipsoidDlg;
	  CDeleteEllipsoid* p_DeleteEllipsoidDlg;
	  CDeleteDatumView* p_DeleteDatumDlg;
    Precision precis;
    char current_dir[256];

protected:
    CSplitterWnd* m_pSplitter;
    virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
        
protected: // create from serialization only
    CMainFrame();
    DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
    HBRUSH GetBackgroundBrush();
    COLORREF GetBackgroundColor();
    COLORREF GetTextColor();
    
// Operations
public:
    void GetAccuracy();
    CMasterView* GetUpperView( void );
    CMasterView* GetLowerView( void );
    void Check_3D_Conversion( void );

// Implementation
public:
    virtual ~CMainFrame();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
    CStatusBar  m_wndStatusBar;
    CToolBar    m_wndToolBar;

// Generated message map functions
protected:
    //{{AFX_MSG(CMainFrame)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnHelpHelp();
    afx_msg void OnOptionsColorsBackground();
    afx_msg void OnOptionsColorsText();
    afx_msg void OnOptionsGeodeticformatSignhemisphereNsew();
    afx_msg void OnOptionsGeodeticformatSignhemispherePlusMinus();
    afx_msg void OnOptionsGeodeticformatUnitsDegreesminutesseconds();
    afx_msg void OnOptionsGeodeticformatUnitsDegreesminutes();
    afx_msg void OnOptionsGeodeticformatUnitsDegree();
    afx_msg void OnUpdateOptionsGeodeticformatSignhemisphereNsew(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsGeodeticformatSignhemispherePlusMinus(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsGeodeticformatUnitsDegree(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsGeodeticformatUnitsDegreesminutes(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsGeodeticformatUnitsDegreesminutesseconds(CCmdUI* pCmdUI);
    afx_msg void OnFileOpen();
    afx_msg void OnOptionsPrecision100000m();
    afx_msg void OnOptionsPrecision10000m();
    afx_msg void OnOptionsPrecision1000m();
    afx_msg void OnOptionsPrecision100m();
    afx_msg void OnOptionsPrecision10m();
    afx_msg void OnOptionsPrecision1m();
    afx_msg void OnOptionsPrecisionPnt1m();
    afx_msg void OnUpdateOptionsPrecision100000m(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsPrecision10000m(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsPrecision1000m(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsPrecision100m(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsPrecision10m(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsPrecision1m(CCmdUI* pCmdUI);
    afx_msg void OnUpdateOptionsPrecisionPnt1m(CCmdUI* pCmdUI);
	  afx_msg void OnOptionsGeodeticformatSeparatorBlankspace();
	  afx_msg void OnUpdateOptionsGeodeticformatSeparatorBlankspace(CCmdUI* pCmdUI);
	  afx_msg void OnUpdateOptionsGeodeticformatSeparatorSlash(CCmdUI* pCmdUI);
	  afx_msg void OnOptionsGeodeticformatSeparatorSlash();
	  afx_msg void OnOptionsGeodeticformatSeparatorColon();
	  afx_msg void OnUpdateOptionsGeodeticformatSeparatorColon(CCmdUI* pCmdUI);
	  afx_msg void OnUpdateOptionsGeodeticformatLongituderange180180(CCmdUI* pCmdUI);
	  afx_msg void OnOptionsGeodeticformatLongituderange180180();
	  afx_msg void OnOptionsGeodeticformatLongituderange0360();
	  afx_msg void OnUpdateOptionsGeodeticformatLongituderange0360(CCmdUI* pCmdUI);
	  afx_msg void OnChangeAccuracy();
	  afx_msg void OnOptionsPrecision1cm();
	  afx_msg void OnUpdateOptionsPrecision1cm(CCmdUI* pCmdUI);
	  afx_msg void OnOptionsPrecision1mm();
	  afx_msg void OnUpdateOptionsPrecision1mm(CCmdUI* pCmdUI);
	  afx_msg void OnDatumCreate();
	  afx_msg void OnDatumDelete();
	  afx_msg void OnEllipsoidCreate();
	  afx_msg void OnEllipsoidDelete();
	  afx_msg void OnConvertUppertoLower();
	  afx_msg void OnConvertLowertoUpper();
	afx_msg void OnCreateHeader();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
